package jp.turbosql.modules.db.app;

import javax.swing.JInternalFrame;
import javax.swing.JDesktopPane;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class ConsoleFrame extends JFrame
{
    JDesktopPane desktop;
    public ConsoleFrame()
    {
        super("Database Browser");
        
        int inset = 50;
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setBounds(inset, inset, 
                  screenSize.width - inset*2, 
                  screenSize.height-inset*2);
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        addWindowListener(new WindowHandler());
        
        desktop = new JDesktopPane(); //a specialized layered pane
        //createFrame(); //Create first window
        setContentPane(desktop);
        //setJMenuBar(createMenuBar());

        //Make dragging faster:
        desktop.putClientProperty("JDesktopPane.dragMode", "outline");
        
        
        //pack();                                 // layout the components at their appropriate sizes
        
        setVisible(true);                       // Set window visible
        show();        
    } // public ConsolseFrame()
    
    public static void main(String[] args)
    {
        ConsoleFrame frame = new ConsoleFrame();
    } // public static void main(String[] args)
    
    // Inner class defining handler for window events
    class WindowHandler extends WindowAdapter
    {
        // Handler for window closing event
        public void windowClosing(WindowEvent e)
        {
            dispose();                          // Release the window resources
            System.exit(0);                     // End the application
        } // public void windowClosing(WindowEvent e)
        
    } // class WindowHandler extends WindowAdapter
    
} // public class ConsoleFrame extends Frame


